<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from suif1.texi on 28 April 1999 -->

<TITLE>The SUIF Version 1 Library - Types</TITLE>
<link href="suif1_60.html" rel=Next>
<link href="suif1_58.html" rel=Previous>
<link href="suif1_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_58.html">previous</A>, <A HREF="suif1_60.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
<P><HR><P>


<H1><A NAME="SEC59" HREF="suif1_toc.html#TOC59">Types</A></H1>
<P>
<A NAME="IDX412"></A>

</P>
<P>
<A NAME="IDX413"></A>
<A NAME="IDX414"></A>
SUIF types are used to describe the results of instructions and the
contents of variables.  Each symbol table (see section <A HREF="suif1_40.html#SEC40">Symbol Tables</A>)
contains a list of types that are visible within the scope of that
table.  All SUIF types are derived from the <CODE>type_node</CODE> base class,
which is defined in the files <TT>`types.h'</TT> and <TT>`types.cc'</TT>.  The
<CODE>type_node_list</CODE> class is provided for lists of pointers to types.

</P>
<P>
<A NAME="IDX415"></A>
<A NAME="IDX416"></A>
Different kinds of type nodes are distinguished by their type operators.
The <CODE>op</CODE> method returns the operator for a particular
<CODE>type_node</CODE>.  Some type operators define complete types by
themselves while others build upon existing types.  The <CODE>type_ops</CODE>
enumeration lists the type operators:

</P>
<DL COMPACT>

<DT><CODE>TYPE_VOID</CODE>
<DD>
<DT><CODE>TYPE_INT</CODE>
<DD>
<DT><CODE>TYPE_FLOAT</CODE>
<DD>
These operators, along with <CODE>TYPE_ENUM</CODE> below, define the base
types.  They use the <CODE>base_type</CODE> derived class.

<DT><CODE>TYPE_PTR</CODE>
<DD>
A pointer operator defines a type for pointers to an existing
type.  The <CODE>ptr_type</CODE> derived class holds this kind of type node.

<DT><CODE>TYPE_ARRAY</CODE>
<DD>
The array operator uses the <CODE>array_type</CODE> class and defines a type
that is an array with elements of another type.

<DT><CODE>TYPE_FUNC</CODE>
<DD>
The function operator defines a type for a SUIF procedure in terms of
the return type and the types of the arguments.  The <CODE>func_type</CODE>
derived class is used with this operator.

<DT><CODE>TYPE_STRUCT</CODE>
<DD>
<DT><CODE>TYPE_UNION</CODE>
<DD>
These operators are for named structure and union types and both use the
<CODE>struct_type</CODE> derived class.  Both combine fields of different
types into a single record.

<DT><CODE>TYPE_ENUM</CODE>
<DD>
The enumerated type operator defines an integer type where each value
may have a name.  Like the ordinary integer types, enumerated types are
also base types.  Thus, the <CODE>enum_type</CODE> class is derived from the
<CODE>base_type</CODE> class.

<DT><CODE>TYPE_CONST</CODE>
<DD>
<DT><CODE>TYPE_VOLATILE</CODE>
<DD>
<DT><CODE>TYPE_CALL_BY_REF</CODE>
<DD>
<DT><CODE>TYPE_NULL</CODE>
<DD>
These operators are modifiers for other types.  They use the
<CODE>modifier_type</CODE> derived class.
</DL>

<P>
<A NAME="IDX417"></A>
The integer, floating-point, pointer, and enumerated types are all
classified as <STRONG>scalar</STRONG> types, and the <CODE>is_scalar</CODE> method checks
if a type is one of these.  The array, structure, and union types
are all <STRONG>aggregate</STRONG> types.

</P>
<P>
The <CODE>type_node</CODE> base class defines several methods that are
applicable to all types, and those are described in the first section
below along with some other comments about types in general.  The bulk
of this chapter is devoted to the various kinds of types and the
corresponding derived classes.  The last section describes the common
types that are predefined in the global symbol table.

</P>

<UL>
<LI><A HREF="suif1_60.html#SEC60">Type Features</A>: Features shared by all types.
<LI><A HREF="suif1_61.html#SEC61">Base Types</A>: Void, integer, and floating-point types.
<LI><A HREF="suif1_62.html#SEC62">Pointer Types</A>: Pointers.
<LI><A HREF="suif1_63.html#SEC63">Array Types</A>: Arrays.
<LI><A HREF="suif1_64.html#SEC64">Function Types</A>: Types for SUIF procedures.
<LI><A HREF="suif1_65.html#SEC65">Structure Types</A>: Structures and unions.
<LI><A HREF="suif1_66.html#SEC66">Enumerated Types</A>: Lists of named values.
<LI><A HREF="suif1_67.html#SEC67">Modifier Types</A>: Qualifiers for other types.
<LI><A HREF="suif1_68.html#SEC68">Predefined Types</A>: Simple types in the global symbol table.
</UL>

<P><HR><P>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_58.html">previous</A>, <A HREF="suif1_60.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
</BODY>
</HTML>
